#define IDIRT_MAILER
#define MAX_MAIL 2048

#ifndef IDIRT_MAILER
#ifndef CDIRT_MAILER
#ifndef STUB_MAILER
#define STUB_MAILER
#endif
#endif
#endif

#ifdef IDIRT_MAILER

#include <stdio.h>
#include <unistd.h>

#include "kernel.h"
#include "mudtypes.h"
#include "uaf.h"
#include "abermail.h"
#include "mailer.h"
#include "sendsys.h"
#include "mobile.h"
#include "client.h"

char *abermail_store(char *from, char *frommud, char *to, char *subject, char *date, char *data) {
  int plx;
  PERSONA p;
  plx = fpbn(to);
  
  if (getuaf(to, &p)) {
    char dest[256];
    char fname[256], fname2[256];
    FILE *f;
    strcpy(dest, p.p_name);
    
    sprintf(fname, "abermail.tmp.%i.%i", (int)getpid(), (int)time(NULL));
    f = fopen(fname, "w");
    
    if (f) {
      int plr;
      fprintf(f, "T\n");
      /*frommud[4] = 0;*/
      fprintf(f, "%s@@%s\n", from, frommud);
      fprintf(f, "%s\n", subject);
      fprintf(f, "%s\n", date);
      fprintf(f, "%s\n", data);
      fprintf(f, "%c\n", EOM_MARKER);
      fclose(f);
      
      sprintf(fname2, "%s/%s", MAIL_DIR, dest);
      if (append_file(fname2, fname)) {
	
	if ((plr = fpbns(dest)) >= 0) {
	  sendf(plr, "%s\n", NEW_MAIL_MSG);
	  if (players[plr].inmailer)
	    reindex_mail(plr);
	}
      } else {
	return "Cannot open mailbox.";
      }
      
      unlink(fname);
      return "Mail stored.";
    }
    
  } else {
    return "User not found.";
  }
  return 0;
}


void abermail_handle(void) {
  char buffer[MAX_MAIL];
  char subject[256];
  char date[256];
  char from[256];
  char to[256];
  char *tomud;
  char junk[256];
  FILE *f = fopen(cur_player->Mailer.outputname, "r");
  if (!f) return;
  fgets(junk, 256, f);
  fgets(from, 256, f);
  fgets(subject, 256, f);
  fgets(date, 256, f);
  strncpy(to, cur_player->Mailer.sendto, sizeof to);
  tomud = strchr(to, '@');
  if (!tomud) {
    fclose(f);
    return;
  }
  *tomud = 0;
  tomud++;
  strcpy(buffer, "");
  while (1) {
    fgets(junk, 256, f);
    junk[255] = 0;
    if (junk[0]==EOM_MARKER) break;
    strncat(buffer, junk, MAX_MAIL-1);
  }
  fclose(f);
  if (strchr(from, '\n')) *strchr(from, '\n')=0;
  if (strchr(subject, '\n')) *strchr(subject, '\n')=0;
  if (strchr(date, '\n')) *strchr(date, '\n')=0;
  buffer[MAX_MAIL-1] = 0;
  aberchat_sendmail(from, to, tomud, subject, date, buffer);
}

#endif

#ifdef CDIRT_MAILER

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include "kernel.h"
#include "abermail.h"
#include "client.h"
#include "extern.h"
#include "bprintf.h"
#include "mail.h"
#include "mud.h"
#include "uaf.h"

char *abermail_store(char *from, char *frommud, char *to, char *subject, char *date, char *data) {
	FILE *f;
	time_t t;
	char c_date[256];
	char fname[256];	
	struct tm *tm;
	int sendto;
	PERSONA p;
	
	if (!getuaf(to, &p)) {
		return "No such user";
	}
	
	sprintf(fname, "%s/%s", MAILDIR, p.ublock.pname);
	f = fopen(fname, "a");
	if (!f) return "Cannot open mailbox.";
	fprintf(f, "From: %s@%s\n", from, frommud);
	fprintf(f, "Subject: %s\n", subject);
	t = atoi(date);
	tm = localtime(&t);
	strftime(c_date, 80, "%a %b %d, %I:%M%P", tm);
	fprintf(f, "Date: %s\n", c_date);
	fprintf(f, "Status: N\n");
	fprintf(f, "%s", data);
	fprintf(f, DELIM "\n");	
	fclose(f);
	
	sendto = fpbn(to);
	if (sendto != -1) {
		if (players[sendto].inmailer) {
			int tmp_mynum = real_mynum;
			setup_globals(sendto);
			loadmail();
			listmail();
			setup_globals(tmp_mynum);
		}
		ssetflg(sendto, SFL_MAIL);
		sendf(sendto, "&+Y***&+W\a You have recieved new mail from %s@%s &+Y***\n",
			  from, frommud);
	} else {
		if (getuaf(to, &p)) {
			set_bit(&p.ublock.psflags, SFL_MAIL);
			putuaf(&p);
		}
	}
	
	return "Mail stored.";
}


void abermail_handle(void) {
    FILE *f;
	char buffer[1024], from[1024], subject[1024], date[1024], mail[MAX_MAIL], to[256], *tomud;
	f = fopen(cur_player->edit_outfile, "r");
	if(!f) {
		bprintf("Some kind of problem... Sorry...\n");
		return;
	}
  	
	fgets(buffer, 1000, f);
  	strcpy(from, buffer+6);
  	if (strchr(from, '\n')) *strchr(from, '\n')=0;
	
	fgets(buffer, 1000, f);
	strcpy(subject, buffer+8);
  	if (strchr(subject, '\n')) *strchr(subject, '\n')=0;
  	
	fgets(buffer, 1000, f);
  	sprintf(date, "%i", (int)time(NULL));
	
	fgets(buffer, 1000, f);
	
	strcpy(mail, "");
	
	while (1) {
		fgets(buffer, 1000, f);
		if (feof(f)) break;
		if (strncmp(buffer, DELIM, 3)==0) break;
		strncat(mail, buffer, MAX_MAIL-1);
	}

	strncpy(to, cur_player->work_msg->mailto, sizeof to);
	tomud = strchr(to, '@');
	if (!tomud) {
	  fclose(f);
	  return;
	}

	*tomud = 0;
	tomud++;
	
	aberchat_sendmail(from, to, tomud, subject, date, mail);
	
	fclose(f);
}
#endif

#ifdef OLD_IDIRT_MAILER

/* 
 * this is thanks to Rhadamanthus@XTC, but it would appear that XTC's mailer
 * is not the same as any others. Ignore this.
 */

#include "kernel.h"
#include "stdinc.h"
#include "client.h"

#define EOM_MARKER	"*EOM*"
#define MAILER_DIR	"MAIL"

char *abermail_store(char *from, char *frommud, char *to, char *subject,
		     char *date, char *data)
{
  PERSONA p;
  int  pl;
  FILE *f;
  static char path[256];

  if(!getuaf(to, &p)) {
    sprintf(path, "No such user: %s", to);
    return path;
  }
  sprintf(path, MAILER_DIR "/%s", p.p_name);
  if(!(f = fopen(path, "a"))) return "Local error delivering mail.";
  fprintf(f, "**\n%s@%s\n%s\n%s\n%s\n%s\n*EOM*\n", from, frommud, to,
	  subject, date, data);
  fclose(f);
  if((pl = fpbn(to)) >= 0)
    sendf(pl, "&+W\aYou've got new mail from &+C%s&+c@&+C%s&+W.\n",
	  from, frommud);
  sprintf(path, "Mail to %s safely delivered.", p.p_name);
  return path;
}

/*
 * <skip>
 * <skip>
 * to
 * subject
 * time
 * message
 * <eom>
 */
void abermail_handle(void)
{
  FILE *f = NULL;
  char name[256], to[256], subject[256], *p, c, buf[8192];
  int i;

  sprintf(name, MAILER_DIR "/%s.from-%s", cur_player->mails.w_name,
	  pname(mynum));
  if(!(f = fopen(name, "r"))) goto bleh;
  if(!fgets(to, sizeof(to), f)) goto bleh;
  if(!fgets(to, sizeof(to), f)) goto bleh;
  if(!fgets(to, sizeof(to), f)) goto bleh;
  if(!fgets(subject, sizeof(subject), f)) goto bleh;
/* name holds time for some reason :P */
  if(!fgets(name, sizeof(name), f)) goto bleh;
  for(i = 0, c = getc(f); c != EOF; c = getc(f)) {
    if(i >= sizeof(buf)) break;
    buf[i++] = c;
  }
  buf[i] = 0;
  fclose(f);
  if((p = strstr(buf, EOM_MARKER))) *p = 0;
  if((p = strchr(to, '\n'))) *p = 0;
  if((p = strchr(subject, '\n'))) *p = 0;
  if((p = strchr(name, '\n'))) *p = 0;
  if((p = strchr(to, '@'))) *p++ = 0;
  else p = to + strlen(to);
  aberchat_sendmail(pname(mynum), to, p, subject, name, buf);
  fclose(f);
  return;

bleh:
  if(f) fclose(f);
  bprintf("Error sending mail!\n");
}
#endif

#ifdef STUB_MAILER

#include <stdio.h>
#include <unistd.h>

#include "kernel.h"
#include "abermail.h"
#include "client.h"
#include "bprintf.h"

char *abermail_store(char *from, char *frommud, char *to, char *subject, char *date, char *data) {
	return "abermail not implemented here.";
}


void abermail_handle(void) {
	bprintf("Outgoing Abermail not working...\n");
}


#endif
